//+------------------------------------------------------------------------------------------+
//|                                                                         DailyData.mq4    |
//|                                                                                mladen    |
//|   Version: DailyData_v01.mq4   by okfar (forex-tsd forum nick)                           |
//|         - add changable fontsize                                                         |
//|         - add changable distance from top                                                |
//|         - add ADX indicator (timeframe: MN1 - Monthly, W1-Weekly, D1-Daily, H4-4 hour)   | 
//|                                                                                          |
//|   Version: DailyData_v02.mq4   by okfar (forex-tsd forum nick)                           |
//|         - redefine distance from top (independant from fontsize)                         |
//|         - simplifying the addition unlimit of the indicators and value of info (numeric) | 
//|                                                                                          |
//+------------------------------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Maroon
#property indicator_color3  Lime
#property indicator_color4  Red
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2


extern color zoneColor      = C'30,33,36';
extern int   CandleShift    = 8;
extern bool  ShowInfo       = True;
extern bool  ShowSwap       = True;
extern bool  ShowBackground = True;
extern bool  ShowBar        = True;

extern bool    ShowInd      = True;           //Show indicators: ON = True, OFF = False 

extern int y   = 25;                          //verical distance from top                   
extern int fontsize=  10;                     //Font size



//-------------
// Indicators (info) names - number names = number indicators != limit 
// CHANGE THIS!!!      
string indtxt[]={ "Data Period(Hour):", "SMA50-H1:", "EMA21-H1:","SMMA21-H1:", "LWMA21-H1:", "Stoh1-H1:", "Stoh2-H1:", "DayChange(%):", "WeekChange(%):", "MonthChange(%):" };
//--------------


double DayHigh[];
double DayLow[];
double DayOpen[];
double DayClose[];
double prevCurr =-1;
int    DataPeriod;
int    DataBar;
string indNames = "DailyData";



double dy=0,
       dx=0;
int y2;
int numind;


 
int digit[];

double tmp;
double value[];
string valuetxt[][];


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//---- indicators

void init()
{
   SetIndexBuffer(0, DayHigh);
   SetIndexBuffer(1, DayLow);
   SetIndexBuffer(2, DayClose);
   SetIndexBuffer(3, DayOpen);
      if (ShowBar)
         for (int i=0;i<4;i++)
            {
               SetIndexStyle(i,DRAW_HISTOGRAM);
               SetIndexShift(i,CandleShift);
               SetIndexLabel(i,"Daily data");
            }            
      else  for (i=0;i<4;i++) SetIndexStyle(i,DRAW_NONE);
            


   switch(Period())
   {
      case PERIOD_MN1:
      case PERIOD_W1:  DataPeriod = PERIOD_MN1; break;
      case PERIOD_D1:  DataPeriod = PERIOD_W1;  break;
      default:         DataPeriod = PERIOD_D1;
   }
   prevCurr = -1;
   
   dy=(fontsize/10.0);
   dx=(fontsize/15.0);
   
   numind = ArraySize( indtxt); 
   ArrayResize( value, numind); 
   ArrayResize( digit, numind);
   for (i=0; i<numind ;i++) 
      digit[i]=2;
   
   
   return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   for (int counter=-1; counter<(17+2*numind); counter++) ObjectDelete(indNames+counter);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+


int start()
{
  
//----
      


//-----------------------------------
// Indicators (info) calculation)
// value[0] -> first name  of indtxt[]
// CHANGE THIS!!!!!
   
   value[0] = DataPeriod/60.0;
   value[1] = iMA(Symbol(), PERIOD_H1, 21,  0, MODE_SMA, PRICE_CLOSE, 0);
   value[2] = iMA(Symbol(), PERIOD_H1, 21,  0, MODE_EMA, PRICE_CLOSE, 0);
   value[3] = iMA(Symbol(), PERIOD_H1, 21,  0, MODE_SMMA, PRICE_CLOSE, 0);
   value[4] = iMA(Symbol(), PERIOD_H1, 21,  0, MODE_LWMA, PRICE_CLOSE, 0);
   value[5] = iStochastic(Symbol(), PERIOD_H1, 14, 3, 3, MODE_SMA, 1, MODE_MAIN, 0);
   value[6] = iStochastic(Symbol(), PERIOD_H1, 8, 3, 3, MODE_SMA, 1, MODE_MAIN, 0);
   
   double OpenTime = 7;
   value[7] = 100*(MarketInfo(Symbol(), MODE_BID)/iOpen(Symbol(),PERIOD_H1,TimeHour(TimeCurrent())-OpenTime)-1);
   value[8] = 100*(MarketInfo(Symbol(), MODE_BID)/iOpen(Symbol(),PERIOD_H1,24*(TimeDayOfWeek(TimeCurrent())-1)+TimeHour(TimeCurrent())-OpenTime)-1);
   value[9] = 100*(MarketInfo(Symbol(), MODE_BID)/iOpen(NULL,PERIOD_MN1,0)-1);
   
//Number of dispayed digits for indicators (info)        indtxt[] -> value[0] -> digit[0]  
// default is 2 for all data other data
   digit[0]=0;
   digit[1]=5;
   digit[2]=5;
   digit[3]=5;
   digit[4]=5;
   digit[5]=3;
   
//-----------------------------------------  
  
  
  
  
  fDailyData_v01();


//----
   return(0);
}
//+------------------------------------------------------------------+



void fDailyData_v01()
{
 
   
   int    digits   = MarketInfo(Symbol(),MODE_DIGITS);
   double modifier = 1;
   
   if (digits==3 || digits==5) modifier = 10.0;
   else if (ObjectFind(indNames+"16"+numind) != -1)
      ObjectDelete(indNames+"26"+numind);
      
      //
      //
      //
      //
      //
            
   DataBar  = iBarShift(NULL,DataPeriod,Time[0]);
   double HiDAILY  = iHigh (NULL,DataPeriod,DataBar);
   double LoDAILY  = iLow  (NULL,DataPeriod,DataBar); 
   double current  = iClose(NULL,DataPeriod,DataBar);
   double range    = getRange(DataPeriod)/modifier;
   double change   = (current-iOpen(NULL,DataPeriod,DataBar))/(Point*modifier);
   int    limit,i;
      
      //
      //
      //
      //
      //

   if (ShowInfo)   {
      if (ObjectFind(indNames+"1") ==-1) {
         objectCreate("1",10*dx,10*dy+y,"-------------------------------------",fontsize,NULL);  
         objectCreate("3",60*dx,32*dy+y,"distance from high : ",fontsize);
         objectCreate("4",60*dx,44*dy+y,"distance from low : " ,fontsize);
         objectCreate("5",10*dx,56*dy+y,"-------------------------------------",fontsize,NULL);
         if (ShowSwap) {
            objectCreate("2",60*dx,20*dy+y,"change/range : ",fontsize);
            objectCreate("6",60*dx,64*dy+y,"swap long : "         ,fontsize);
            objectCreate("7",60*dx,76*dy+y,"swap short : "        ,fontsize);
            objectCreate("8",10*dx,84*dy+y,"--------------------------------------",fontsize,NULL);  
         }
         else  {
            objectCreate("2",60*dx,20*dy+y,"range : "       ,fontsize);
            objectCreate("6",60*dx,64*dy+y,"distance from open : ",fontsize);
            objectCreate("8",10*dx,76*dy+y,"---------------------------------------",fontsize,NULL);  
         }                     
      }

         //
         //
         //
         //
         //

      if (prevCurr != current) {
         prevCurr = current;
         double currFromHi = (HiDAILY-current)/(Point*modifier);
         double currFromLo = (current-LoDAILY)/(Point*modifier);

                  //
                  //
                  //
                  //
                  //
                  
         objectCreate("0",128*dx,0*dy+y,Symbol(),fontsize,"Arial bold",YellowGreen);  
         if (ShowSwap)
            objectCreate("10",10*dx,20*dy+y,DoubleToStr(change,0)+"/"+DoubleToStr(range,0)    ,fontsize,"Arial bold",Gold);
         else  
            objectCreate("10",10*dx,20*dy+y,                          DoubleToStr(range,0)    ,fontsize,"Arial bold",Gold);
         objectCreate("11",10*dx,32*dy+y,DoubleToStr(currFromHi,0)                         ,fontsize,"Arial bold",YellowGreen);
         objectCreate("12",10*dx,44*dy+y,DoubleToStr(currFromLo,0)                         ,fontsize,"Arial bold",YellowGreen);
         if (ShowSwap)  {
            objectCreate("13",10*dx,64*dy+y,DoubleToStr(MarketInfo(Symbol(),MODE_SWAPLONG),2) ,fontsize,"Arial bold",YellowGreen);
            objectCreate("14",10*dx,76*dy+y,DoubleToStr(MarketInfo(Symbol(),MODE_SWAPSHORT),2),fontsize,"Arial bold",YellowGreen);
         }
         else {
            if (change<0)
               objectCreate("13",10*dx,64*dy+y,DoubleToStr(change,0) ,fontsize,"Arial bold",Red);
            else  objectCreate("13",10*dx,64*dy+y,DoubleToStr(change,0) ,fontsize,"Arial bold",Gold);
         }
         string currentValue = DoubleToStr(current,digits);                  
         objectCreate("15",10*dx, 0*dy+y,currentValue,fontsize+2,"Arial bold",YellowGreen);  
         if (modifier !=1)
            objectCreate("16",10*dx, 0*dy+y,StringSubstr(currentValue,StringLen(currentValue)-1),fontsize+2,"Arial bold",Gold);  
            
         if (ShowInd) {
            if (ShowSwap)
               y2=84;
            else 
               y2=76;
                  
            for (i=0; i<numind ;i++) {
               valuetxt[i][0] = DoubleToStr(value[i], digit[i]);               
               objectCreate(2*i+17,70*dx,(y2+12*(i+1))*dy+y,indtxt[i],fontsize);
               objectCreate(2*i+18,10*dx,(y2+12*(i+1))*dy+y, valuetxt[i][0], fontsize,  "Arial bold",YellowGreen);  
            } 
         }
      }   
   }           
   setBarIndicator(change,HiDAILY,LoDAILY,iOpen(NULL,DataPeriod,DataBar),current);
   for(i=0,limit=Bars-1;i<4;i++) SetIndexDrawBegin(i,limit); 
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+  
//
//
//
//
//

void setBarIndicator(double change, double hi,double low, double open, double close)
{
   string name  = indNames+"-1";
   int    shift = 0;
   
   if (change>0) { DayHigh[shift]  = hi;  DayLow[shift] = low; }            
   else          { DayHigh[shift]  = low; DayLow[shift] = hi;  }            
                   DayOpen[shift]  = open;
                   DayClose[shift] = close;

   if (ShowBackground)
      {                         
         if (ObjectFind(name) == -1)
             ObjectCreate(name,OBJ_RECTANGLE,0,0,0);
             ObjectSet(name,OBJPROP_TIME1,iTime(NULL,DataPeriod,DataBar));
             ObjectSet(name,OBJPROP_TIME2,iTime(NULL,         0,0));
             ObjectSet(name,OBJPROP_PRICE1,hi);
             ObjectSet(name,OBJPROP_PRICE2,low);
             ObjectSet(name,OBJPROP_COLOR,zoneColor);
      }             
}

//
//
//
//
//

double getRange(int period)
{
      double range = iHigh(NULL, period, DataBar) - iLow(NULL, period, DataBar);
      return (NormalizeDouble(range/Point,0));
}

//
//
//
//
//

void objectCreate(string name,int x,int y,string text="-",int size=10,
                  string font="Arial",color colour=DimGray,int window = 0)
{
   if (ObjectFind(indNames+name) == -1)
   {
      ObjectCreate(indNames+name,OBJ_LABEL,window,0,0);
         ObjectSet(indNames+name,OBJPROP_CORNER,1);
         ObjectSet(indNames+name,OBJPROP_XDISTANCE,x);
         ObjectSet(indNames+name,OBJPROP_YDISTANCE,y);
   }               
   ObjectSetText(indNames+name,text,size,font,colour);
}


